using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ForgePC.Forms
{
    public partial class Update : Form
    {
        Updating update;

        public Update()
        {
            InitializeComponent();
        }

        public void BeingUpdate()
        {
            //Create a new updater
            update = new Updating();

            //Add our handlers and being the download
            update.AsyncCompletedEventHandler += new AsyncCompletedEventHandler(update_AsyncCompletedEventHandler);
            update.DownloadProgressChangedEventHandler += new System.Net.DownloadProgressChangedEventHandler(update_DownloadProgressChangedEventHandler);

            labelX2.Text = "Downloading Update...";
            Application.DoEvents();
            update.DownloadUpdate();
        }

        void update_DownloadProgressChangedEventHandler(object sender, System.Net.DownloadProgressChangedEventArgs e)
        {
            //Update our progress
            progressBarX1.Value = e.ProgressPercentage;
        }

        void update_AsyncCompletedEventHandler(object sender, AsyncCompletedEventArgs e)
        {
            //Reset the progress to 0
            progressBarX1.Value = 0;

            //Update our label
            labelX2.Text = "Unpacking Update...";
            Application.DoEvents();

            //We have completed the download so lets unpack now
            update.UnpackUpdate();

            //Now delete the update
            update.DeleteUpdate();
            
            labelX2.Text = "Update Complete...";
           
            //Now lets restart the app so we can perform a cleanup
            DialogResult dr = MessageBox.Show("You must restart the Engineer for the updates to take effect.\nWould you like to restart now?", "Restart", MessageBoxButtons.YesNo);
            if (dr == DialogResult.Yes)
            {
                System.Diagnostics.Process.Start(Application.ExecutablePath);   
                Application.Exit();
            }
        }

        private void Update_Load(object sender, EventArgs e)
        {
            BeingUpdate();
        }

    }
}