using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using ForgePC.Map;

namespace entity.Forms.Meta_Editor
{
    public partial class EntStrings : UserControl
    {
        public int LineNumber;
        private int mapIndex;
        public int chunkOffset;
        private int offsetInMap;
        private string value = "";
        private int length;
        public string EntName = "Error in getting plugin element name";
        private bool entUnicode;
        private bool isNulledOutReflexive = true;
        public EntStrings(string iEntName, int map, int iOffsetInChunk, int ilength, bool itype, int iLineNumber)
        {
            this.LineNumber = iLineNumber;
            this.entUnicode = itype;
            this.length = ilength;
            mapIndex = map;
            this.EntName = iEntName;
            this.chunkOffset = iOffsetInChunk;
            InitializeComponent();
            this.Controls[1].Text = EntName;
            this.Dock = DockStyle.Top;
            this.Size = this.PreferredSize;
            this.AutoSize = false;
        }
        public void Populate(int iOffset)
        {
            this.isNulledOutReflexive = false;
            bool openedMap = false;
            if (Maps.map[mapIndex].isOpen == false)
            {
                Maps.map[mapIndex].Open(H3Dev.IO.EndianType.BigEndian, H3Dev.Map.H3Map.MapType.Internal);
                openedMap = true;
            }
            Maps.map[mapIndex].io.In.BaseStream.Position = iOffset + this.chunkOffset;
            this.offsetInMap = iOffset + this.chunkOffset;
            Encoding decode = Encoding.UTF8;
            byte[] tempbytes = Maps.map[mapIndex].io.In.ReadBytes(this.length);
            this.value = decode.GetString(tempbytes);
            this.RemoveNullCharFromValue();
            ((TextBox)this.Controls[0]).Text = this.value;
            ((TextBox)this.Controls[0]).Size = ((TextBox)this.Controls[0]).PreferredSize;
            ((TextBox)this.Controls[0]).Width += 5;
            if (openedMap == true)
                Maps.map[mapIndex].Close();
        }
        private void RemoveNullCharFromValue()
        {
            List<char> tempchar = new List<char>(0);
            tempchar.AddRange(this.value.ToCharArray());            
            for (int counter = 0; counter < tempchar.Count; counter++)
            {
                if (tempchar[counter] == '\0')
                {
                    tempchar.RemoveAt(counter);
                    counter--;
                }
            }
            this.value = new string(tempchar.ToArray());
        }
        public void Save()
        {
            if (this.isNulledOutReflexive == true)
                return;
            if (this.entUnicode == true)
                return;
            if (this.value == "e1_mars_entry12")
                this.value = "e1_mars_entry12";
            bool openedMap = false;
            if (Maps.map[mapIndex].isOpen == false)
            {
                Maps.map[mapIndex].Open(H3Dev.IO.EndianType.BigEndian, H3Dev.Map.H3Map.MapType.Internal);
                openedMap = true;
            }
            Maps.map[mapIndex].io.Out.BaseStream.Position = this.offsetInMap;
            for (int counter = 0; counter < this.length / 4; counter++)
            {
                Maps.map[mapIndex].io.Out.Write((int)0);
            }
            Maps.map[mapIndex].io.Out.BaseStream.Position = this.offsetInMap;
            //if (this.entUnicode == true)
            //{
            //    for (int counter = 0; counter < this.value.Length; counter++)
            //    {
            //        Maps.map[mapIndex].BW.Write((char)this.value[counter]);
            //        if (Maps.map[mapIndex].BW.BaseStream.Position < (long)this.offsetInMap + 2 * (counter+1))
            //            Maps.map[mapIndex].BW.BaseStream.Position++;
            //    }
            //}
            //else
            //{
                for (int counter = 0; counter < this.value.Length; counter++)
                {
                    Maps.map[mapIndex].io.Out.Write((char)this.value[counter]);
                }
            //}            
            if (openedMap == true)
                Maps.map[mapIndex].Close();
        }
        private void textBox1_TextChanged(object sender, System.EventArgs e)
        {
            ((TextBox)this.Controls[0]).Size = ((TextBox)this.Controls[0]).PreferredSize;
            this.Controls[1].Location = new Point(((TextBox)sender).Location.X + ((TextBox)sender).PreferredSize.Width + 5,6);
            this.value = ((TextBox)sender).Text;
        }
        public void SetFocus(int LineToCheck)
        {
            if (this.LineNumber == LineToCheck)
                this.Focus();
        }
    }
}
