using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using entity.Forms.Meta_Editor;
using ForgePC.IFP;
using ForgePC.Map;

namespace entity.Forms.Meta_Editor
{
    public partial class ReflexiveControl : UserControl
    {
        #region fields
        public int LineNumber;
        private int mapIndex;
        private int mapOffset;
        private int offsetInMeta;
        private int translatedOffset;
        private int selectedChunk;
        private int chunkSize;
        private object[] reflexiveItems;
        private string reflexiveLabel;
        private int controlIndexer;
        private int labelOffset;
        public int chunkCount;
        private bool hasChunkCount = true;
        private int oneUpReflexiveBlockOffset;
        #endregion
        #region constructor
        public ReflexiveControl(int map, int offset, bool iHasChunkCount, int iLineNumber)
        {
            this.LineNumber = iLineNumber;
            InitializeComponent();
            this.mapIndex = map;
            this.mapOffset = offset;
            this.hasChunkCount = iHasChunkCount;
        }
        #endregion
        public void LoadENTControls(IFPIO.Reflexive reflexive, object[] entArray, bool clearControls, int layer, ref int tabIndex)
        {
            int over = 20;
            if (clearControls == true)
                this.Controls.Clear();
            this.reflexiveItems = entArray;
            this.reflexiveLabel = reflexive.label;
            this.Dock = DockStyle.Top;
            this.AutoSize = true;
            this.BackColor = System.Drawing.Color.FromArgb(255, ShiftColors.ShiftRed(layer), ShiftColors.ShiftGreen(layer), ShiftColors.ShiftBlue(layer));
            this.Padding = new Padding(10);
            this.offsetInMeta = reflexive.offset;
            this.chunkSize = reflexive.chunkSize;
            System.Windows.Forms.ComboBox tempComboBox = new System.Windows.Forms.ComboBox();
            tempComboBox.FormattingEnabled = true;
            tempComboBox.Location = new System.Drawing.Point(over, 0);
            tempComboBox.Name = "reflexive";
            tempComboBox.Size = new System.Drawing.Size(121, 21);
            tempComboBox.Text = "1: ";
            tempComboBox.DropDownStyle = ComboBoxStyle.DropDownList;
            tempComboBox.Dock= DockStyle.Top;
            tempComboBox.KeyPress += new KeyPressEventHandler(tempComboBox_KeyPress);
            tempComboBox.DropDown += new System.EventHandler(this.ReflexiveLoader_DropDown);
            tempComboBox.DropDownClosed += new System.EventHandler(this.ReflexiveLoader_Close);
            tempComboBox.SelectedIndexChanged += new EventHandler(this.ReflexiveLoader_Close);
            System.Windows.Forms.Label tempLabel = new System.Windows.Forms.Label();
            tempLabel.AutoSize = true;
            tempLabel.Location = new System.Drawing.Point(over + tempComboBox.Width, 0 + 3);
            tempLabel.Name = "label1";
            tempLabel.Dock= DockStyle.Top;
            tempLabel.Size = new System.Drawing.Size(35, 13);
            tempLabel.TabIndex = 1;
            tempLabel.Text = ((IFPIO.Reflexive)reflexive).name;
            int tempCBindex = this.Controls.Count;
            this.Controls.Add(tempComboBox);
            this.Controls.Add(tempLabel);
            foreach (object o in entArray)
            {
                IFPIO.BaseObject tempbase = (IFPIO.BaseObject)o;
                if (tempbase.visible == false)
                    if (Meta_Editor.MetaEditor.ShowInvisibles == false)
                        continue;
                switch (tempbase.ObjectType)
                {
                    case IFPIO.ObjectEnum.Reflexive:
                        {
                            if (Meta_Editor.MetaEditor.ShowReflexives == false)
                                break;
                            System.Windows.Forms.Label tempLabel1 = new System.Windows.Forms.Label();
                            tempLabel1.AutoSize = true;
                            tempLabel1.Location = new System.Drawing.Point(0, 0);
                            tempLabel1.Name = "label1";
                            tempLabel1.Dock = DockStyle.Top;
                            tempLabel1.Size = new System.Drawing.Size(35, 13);
                            tempLabel1.TabIndex = 1;
                            ReflexiveControl tempReflexive = new ReflexiveControl(mapIndex, translatedOffset, ((IFPIO.Reflexive)tempbase).HasCount, tempbase.lineNumber);
                            tempReflexive.Location = new System.Drawing.Point(over, 0);
                            tempReflexive.Name = "reflexive";
                            tempReflexive.LoadENTControls((IFPIO.Reflexive)tempbase,((IFPIO.Reflexive)tempbase).items, true,layer+1, ref tabIndex);
                            this.Controls.Add(tempLabel1);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            this.Controls.Add(tempReflexive);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }
                    case IFPIO.ObjectEnum.Ident:
                        {
                            if (Meta_Editor.MetaEditor.ShowIdents == false)
                                break;
                            entity.Forms.Meta_Editor.Ident tempident = new entity.Forms.Meta_Editor.Ident(tempbase.name, mapIndex, tempbase.offset, ((IFPIO.Ident)tempbase).hasTagType, tempbase.lineNumber);
                            tempident.Name = "ident";                            
                            this.Controls.Add(tempident);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }
                    case IFPIO.ObjectEnum.StringID:
                        {
                            if (Meta_Editor.MetaEditor.ShowSIDs == false)
                                break;
                            entity.Forms.Meta_Editor.SID tempSID = new entity.Forms.Meta_Editor.SID(tempbase.name, mapIndex, tempbase.offset, tempbase.lineNumber);
                            tempSID.Name = "sid";
                            this.Controls.Add(tempSID);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }
                    case IFPIO.ObjectEnum.Float:
                        {
                            if (Meta_Editor.MetaEditor.ShowFloats == false)
                                break;
                            DataValues tempFloat = new DataValues(tempbase.name, mapIndex, tempbase.offset, IFPIO.ObjectEnum.Float, tempbase.lineNumber);
                            //Float tempFloat = new Float(tempbase.name, mapIndex, tempbase.offset);
                            tempFloat.Name = "float";
                            this.Controls.Add(tempFloat);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }
                    case IFPIO.ObjectEnum.String32:
                        {
                            if (Meta_Editor.MetaEditor.ShowString32s == false && tempbase.ObjectType == IFPIO.ObjectEnum.String32)
                                break;
                            EntStrings tempstring = new EntStrings(tempbase.name, mapIndex, tempbase.offset, ((IFPIO.IFPString)tempbase).size, ((IFPIO.IFPString)tempbase).type, tempbase.lineNumber);
                            tempstring.Name = "string";
                            tempstring.TabIndex = tabIndex;
                            this.Controls.Add(tempstring);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }
                    case IFPIO.ObjectEnum.UnicodeString256:
                        {
                            if (Meta_Editor.MetaEditor.ShowUnicodeString256s == false)
                                break;
                            goto case IFPIO.ObjectEnum.String32;
                        }
                    case IFPIO.ObjectEnum.UnicodeString64:
                        {
                            if (Meta_Editor.MetaEditor.ShowUnicodeString64s == false)
                                break;                            
                            goto case IFPIO.ObjectEnum.String32;
                        }
                    case IFPIO.ObjectEnum.String256:
                        {
                            if (Meta_Editor.MetaEditor.ShowString256s == false)
                                break;
                            goto case IFPIO.ObjectEnum.String32;
                        }
                    case IFPIO.ObjectEnum.Int:
                        {                            
                            if (((IFPIO.IFPInt)tempbase).entIndex.nulled == true)
                            {
                                if ((Meta_Editor.MetaEditor.ShowInts == false && tempbase.ObjectType == IFPIO.ObjectEnum.Int)
                                    || (Meta_Editor.MetaEditor.ShowShorts == false && tempbase.ObjectType == IFPIO.ObjectEnum.Short)
                                    || (Meta_Editor.MetaEditor.ShowUshorts == false && tempbase.ObjectType == IFPIO.ObjectEnum.UShort)
                                    || (Meta_Editor.MetaEditor.ShowUints == false && tempbase.ObjectType == IFPIO.ObjectEnum.UInt))
                                    break;
                                DataValues tempdatavalues = new DataValues(tempbase.name, mapIndex, tempbase.offset, tempbase.ObjectType, tempbase.lineNumber);
                                this.Controls.Add(tempdatavalues);
                                this.Controls[this.Controls.Count - 1].BringToFront();
                            }
                            else
                            {
                                if ((Meta_Editor.MetaEditor.ShowBlockIndex32s == false && (tempbase.ObjectType == IFPIO.ObjectEnum.Int | tempbase.ObjectType == IFPIO.ObjectEnum.UInt))
                                    || (Meta_Editor.MetaEditor.ShowBlockIndex16s == false && (tempbase.ObjectType == IFPIO.ObjectEnum.Short | tempbase.ObjectType == IFPIO.ObjectEnum.UShort))
                                    || (Meta_Editor.MetaEditor.ShowBlockIndex8s == false && tempbase.ObjectType == IFPIO.ObjectEnum.Byte))
                                    break;
                                Indices tempdatavalues = new Indices(tempbase.name, mapIndex, tempbase.offset, tempbase.ObjectType, ((IFPIO.IFPInt)tempbase).entIndex);
                                this.Controls.Add(tempdatavalues);
                                this.Controls[this.Controls.Count - 1].BringToFront();
                            }
                            break;
                        }
                    case IFPIO.ObjectEnum.Short:
                        {
                            goto case IFPIO.ObjectEnum.Int;
                        }
                    case IFPIO.ObjectEnum.UShort:
                        {
                            goto case IFPIO.ObjectEnum.Int;
                        }
                    case IFPIO.ObjectEnum.UInt:
                        {
                            goto case IFPIO.ObjectEnum.Int;
                        }
                    case IFPIO.ObjectEnum.Unknown:
                        {
                            if (Meta_Editor.MetaEditor.ShowUndefineds == false)
                                break;
                            DataValues tempUndefined = new DataValues(tempbase.name, mapIndex, tempbase.offset, IFPIO.ObjectEnum.Unknown, tempbase.lineNumber);
                            //Float tempFloat = new Float(tempbase.name, mapIndex, tempbase.offset);
                            tempUndefined.Name = "tempUndefined";
                            this.Controls.Add(tempUndefined);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }
                    case IFPIO.ObjectEnum.Bitmask:
                        {
                            if ((Meta_Editor.MetaEditor.ShowBitmask32s == false && ((IFPIO.Bitmask)tempbase).bitmaskSize == 32)
                                    || (Meta_Editor.MetaEditor.ShowBitmask16s == false && ((IFPIO.Bitmask)tempbase).bitmaskSize == 16)
                                    || (Meta_Editor.MetaEditor.ShowBitmask8s == false && ((IFPIO.Bitmask)tempbase).bitmaskSize == 8))
                                break;
                            Bitmask tempbitmask = new Bitmask(tempbase.name, mapIndex, tempbase.offset, ((IFPIO.Bitmask)tempbase).bitmaskSize, ((IFPIO.Bitmask)tempbase).options, tempbase.lineNumber);
                            this.Controls.Add(tempbitmask);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }
                    case IFPIO.ObjectEnum.Byte:
                        {
                            if (((IFPIO.IFPByte)tempbase).entIndex.nulled == true)
                            {
                                if (Meta_Editor.MetaEditor.ShowBytes == false)
                                    break;
                                DataValues tempByte = new DataValues(tempbase.name, mapIndex, tempbase.offset, IFPIO.ObjectEnum.Byte, tempbase.lineNumber);
                                this.Controls.Add(tempByte);
                                this.Controls[this.Controls.Count - 1].BringToFront();
                            }
                            else
                            {
                                if (Meta_Editor.MetaEditor.ShowBlockIndex8s == false)
                                    break;
                                Indices tempdatavalues = new Indices(tempbase.name, mapIndex, tempbase.offset, tempbase.ObjectType, ((IFPIO.IFPByte)tempbase).entIndex);
                                this.Controls.Add(tempdatavalues);
                                this.Controls[this.Controls.Count - 1].BringToFront();
                            }
                            break;
                        }
                    case IFPIO.ObjectEnum.Enum:
                        {
                            if ((Meta_Editor.MetaEditor.ShowEnum32s == false && (((IFPIO.IFPEnum)tempbase).enumSize == 32))
                                    || (Meta_Editor.MetaEditor.ShowEnum16s == false && ((IFPIO.IFPEnum)tempbase).enumSize == 16)
                                    || (Meta_Editor.MetaEditor.ShowEnum8s == false && ((IFPIO.IFPEnum)tempbase).enumSize == 8))
                                break;
                            Enums tempenum = new Enums(tempbase.name, mapIndex, tempbase.offset, ((IFPIO.IFPEnum)tempbase).enumSize, ((IFPIO.IFPEnum)tempbase).options, tempbase.lineNumber);
                            this.Controls.Add(tempenum);
                            this.Controls[this.Controls.Count - 1].BringToFront();
                            break;
                        }

                }
            }
            this.Size = this.PreferredSize;
            this.AutoSize = false;
        }

        void tempComboBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar=='c')
                Clipboard.SetDataObject(((ComboBox)sender).Items[((ComboBox)sender).SelectedIndex], true);
            if (e.KeyChar == 'a')
            {
                string tempStringToCopy = "";
                int ReflexiveChunkSelectionBoxItemLength = ((ComboBox)sender).Items.Count;
                for (int counter = 0; counter < ReflexiveChunkSelectionBoxItemLength; counter++)
                {
                    tempStringToCopy += ((ComboBox)sender).Items[counter].ToString() + System.Environment.NewLine;
                }
                Clipboard.SetDataObject(tempStringToCopy, true);
            }
        }
        private void ReflexiveLoader_DropDown(object sender, EventArgs e)
        {
            UpdateReflexiveSelectionBox(true);
        }
        private void ReflexiveLoader_Close(object sender, EventArgs e)
        {
            this.selectedChunk = ((System.Windows.Forms.ComboBox)sender).SelectedIndex;
            this.LoadMetaIntoControlsForThisReflexive();
        }
        private void LoadMetaIntoControlsForThisReflexive()
        {
            for (int counter = 0; counter < this.Controls.Count; counter++)
            {
                switch (this.Controls[counter].GetType().ToString())
                {
                    case "entity.Forms.Meta_Editor.SID":
                        {
                            ((entity.Forms.Meta_Editor.SID)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize));
                            break;
                        }
                    case "entity.Forms.Meta_Editor.ReflexiveControl":
                        {
                            ((entity.Forms.Meta_Editor.ReflexiveControl)this.Controls[counter]).LoadMetaIntoControls(translatedOffset + (this.selectedChunk * this.chunkSize), this.translatedOffset);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Ident":
                        {
                            ((entity.Forms.Meta_Editor.Ident)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize));
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Float":
                        {
                            ((entity.Forms.Meta_Editor.Float)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize));
                            break;
                        }
                    case "entity.Forms.Meta_Editor.EntStrings":
                        {
                            ((entity.Forms.Meta_Editor.EntStrings)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize));
                            break;
                        }
                    case "entity.Forms.Meta_Editor.DataValues":
                        {
                            ((entity.Forms.Meta_Editor.DataValues)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize));
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Bitmask":
                        {
                            ((entity.Forms.Meta_Editor.Bitmask)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize));
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Enums":
                        {
                            ((entity.Forms.Meta_Editor.Enums)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize));
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Indices":
                        {
                            ((Indices)this.Controls[counter]).Populate(this.translatedOffset + (this.selectedChunk * this.chunkSize),this.oneUpReflexiveBlockOffset);
                            break;
                        }
                }
            }
        }
        public void LoadMetaIntoControls(int startingOffset,int ioneUpReflexiveBlockOffset)
        {
            this.oneUpReflexiveBlockOffset = ioneUpReflexiveBlockOffset;
            this.selectedChunk = 0;
            Maps.map[mapIndex].Open(H3Dev.IO.EndianType.BigEndian, H3Dev.Map.H3Map.MapType.Internal);
            
            Maps.map[mapIndex].io.In.BaseStream.Position = startingOffset + offsetInMeta;
            if (this.hasChunkCount == true)
                this.chunkCount = Maps.map[mapIndex].io.In.ReadUInt16();
            else
                this.chunkCount = 1;
            if (this.chunkCount != 0)
            {
                this.Enabled = true;
                Maps.map[mapIndex].io.In.BaseStream.Position = this.hasChunkCount == true ? startingOffset + offsetInMeta + 4 : startingOffset + offsetInMeta;
                this.translatedOffset = Maps.map[mapIndex].io.In.ReadInt32() - Maps.map[mapIndex].SelectedMeta.Magic;
                this.UpdateReflexiveSelectionBox(false);
                Maps.map[mapIndex].Close();
                this.LoadMetaIntoControlsForThisReflexive();
            }
            else
            { this.Enabled = false; }
            Maps.map[mapIndex].Close();
        }
        private void UpdateReflexiveSelectionBox(bool loadAllChunks)
        {
            bool RightControl = false;
            for (controlIndexer = this.Controls.Count - 1; controlIndexer > -1; controlIndexer--)
            {
                if (this.Controls[controlIndexer].GetType().ToString() == "System.Windows.Forms.ComboBox")
                {
                    RightControl = true;
                    break;
                }
            }
            if (RightControl != true)
                return;
            ((System.Windows.Forms.ComboBox)this.Controls[controlIndexer]).Items.Clear();
            DataValues.ENTType labelType = DataValues.ENTType.nothing;
            for (int counter = 0; counter < this.reflexiveItems.Length; counter++)
            {
                if (((IFPIO.BaseObject)this.reflexiveItems[counter]).name == this.reflexiveLabel
                    && ((IFPIO.BaseObject)this.reflexiveItems[counter]).ObjectType != IFPIO.ObjectEnum.TagType)
                {
                    IFPIO.BaseObject tempbase = (IFPIO.BaseObject)reflexiveItems[counter];
                    this.labelOffset = tempbase.offset;
                    switch (tempbase.ObjectType)
                    {
                        case IFPIO.ObjectEnum.Ident:
                            {
                                labelType = DataValues.ENTType.ident;
                                break;
                            }
                        case IFPIO.ObjectEnum.StringID:
                            {
                              labelType = DataValues.ENTType.sid;
                                break;
                            }
                        case IFPIO.ObjectEnum.Float:
                            {
                                labelType = DataValues.ENTType.Float;
                                break;
                            }
                        case IFPIO.ObjectEnum.String32:
                            {
                                labelType = ((IFPIO.IFPString)tempbase).type == false ? ((IFPIO.IFPString)tempbase).size == 32 ? DataValues.ENTType.string32 : DataValues.ENTType.string256 : ((IFPIO.IFPString)tempbase).size == 64 ? DataValues.ENTType.unicodestring64 : DataValues.ENTType.unicodestring256;
                                break;
                            }
                        case IFPIO.ObjectEnum.UnicodeString256:
                            {
                                goto case IFPIO.ObjectEnum.String32;

                            }
                        case IFPIO.ObjectEnum.String256:
                            {
                                goto case IFPIO.ObjectEnum.String32;

                            }
                        case IFPIO.ObjectEnum.UnicodeString64:
                            {
                                goto case IFPIO.ObjectEnum.String32;

                            }
                        case IFPIO.ObjectEnum.Int:
                            {
                                labelType = DataValues.ENTType.Int32;
                                break;
                            }
                        case IFPIO.ObjectEnum.Short:
                            {
                                labelType = DataValues.ENTType.Int16;
                                break;
                            }
                        case IFPIO.ObjectEnum.UShort:
                            {
                                labelType = DataValues.ENTType.Uint16;
                                break;
                            }
                        case IFPIO.ObjectEnum.UInt:
                            {
                                labelType = DataValues.ENTType.UInt32;
                                break;
                            }
                        case IFPIO.ObjectEnum.Unknown:
                            {
                                goto case IFPIO.ObjectEnum.Float;                                
                            }
                    }
                    break;
                }
            }
            bool openedMap = false;
            if (Maps.map[mapIndex].isOpen == false)
            {
                Maps.map[mapIndex].Open(H3Dev.IO.EndianType.BigEndian, H3Dev.Map.H3Map.MapType.Internal);
                openedMap = true;
            }
            int tempChunkCount = loadAllChunks == true ? chunkCount : 1;
            for (int counter = 0; counter < tempChunkCount; counter++)
            {               
                object tempvalue = "";
                Maps.map[mapIndex].io.In.BaseStream.Position = this.translatedOffset + this.labelOffset + (this.chunkSize * counter);
                switch (labelType)
                {
                    case DataValues.ENTType.Int16:
                        {
                            tempvalue = Maps.map[mapIndex].io.In.ReadInt16();
                            break;
                        }
                    case DataValues.ENTType.Int32:
                        {
                            tempvalue = Maps.map[mapIndex].io.In.ReadInt32();
                            break;
                        }
                    case DataValues.ENTType.Uint16:
                        {
                            tempvalue = Maps.map[mapIndex].io.In.ReadUInt16();
                            break;
                        }
                    case DataValues.ENTType.UInt32:
                        {
                            tempvalue = Maps.map[mapIndex].io.In.ReadUInt32();
                            break;
                        }
                    case DataValues.ENTType.Float:
                        {
                            tempvalue = Maps.map[mapIndex].io.In.ReadSingle();
                            break;
                        }
                    case DataValues.ENTType.undefined:
                        {
                            tempvalue = Maps.map[mapIndex].io.In.ReadSingle();
                            break;
                        }
                    //case DataValues.ENTType.sid:
                    //    {
                    //        int sidIndexer = Maps.map[mapIndex].io.In.ReadInt16();
                    //        tempvalue = Maps.map[mapIndex].Strings.Name[sidIndexer];
                    //        break;
                    //    }
                    //case DataValues.ENTType.ident:
                    //    {
                    //        int tempint = Maps.map[mapIndex].io.In.ReadInt32();
                    //        int tagIndex = Maps.map[mapIndex].Functions.Meta.FindMetaByID(tempint, mapIndex); 
                    //        if (tempint != -1)
                    //        {
                    //            tempvalue = Maps.map[mapIndex].MetaInfo.TagType[tagIndex] + " - " + Maps.map[mapIndex].FileNames.Name[tagIndex];
                    //        }
                    //        else
                    //        {
                    //            tempvalue = "null";
                    //        }
                    //        break;
                    //    }
                    case DataValues.ENTType.string32:
                        {
                            Encoding decode = Encoding.UTF8;
                            byte[] tempbytes = Maps.map[mapIndex].io.In.ReadBytes(32);
                            tempvalue = decode.GetString(tempbytes);
                            break;
                        }
                    case DataValues.ENTType.unicodestring64:
                        {
                            Encoding decode = Encoding.UTF8;
                            byte[] tempbytes = Maps.map[mapIndex].io.In.ReadBytes(64);
                            tempvalue = decode.GetString(tempbytes);
                            break;
                        }
                    case DataValues.ENTType.string256:
                        {
                            Encoding decode = Encoding.UTF8;
                            byte[] tempbytes = Maps.map[mapIndex].io.In.ReadBytes(256);
                            tempvalue = decode.GetString(tempbytes);
                            break;
                        }
                    case DataValues.ENTType.unicodestring256:
                        {
                            goto case DataValues.ENTType.string256;                            
                        }

                }
                ((System.Windows.Forms.ComboBox)this.Controls[controlIndexer]).Items.Add(counter.ToString() + " : " + tempvalue.ToString());
            }
            ((System.Windows.Forms.ComboBox)this.Controls[controlIndexer]).SelectedIndex = this.selectedChunk;
            ((System.Windows.Forms.ComboBox)this.Controls[controlIndexer]).SelectedItem = this.selectedChunk;
            //((System.Windows.Forms.ComboBox)this.Controls[controlIndexer]).Text = ((System.Windows.Forms.ComboBox)this.Controls[controlIndexer]).Items[0].ToString();
            ((System.Windows.Forms.ComboBox)this.Controls[controlIndexer]).SelectionLength = 0;
            if (openedMap == true)
                Maps.map[mapIndex].Close();
        }     
        public void SaveRecursively()
        {
            for (int counter = 0; counter < this.Controls.Count; counter++)
            {
                switch (this.Controls[counter].GetType().ToString())
                {
                    case "entity.Forms.Meta_Editor.SID":
                        {
                            ((entity.Forms.Meta_Editor.SID)this.Controls[counter]).Save();
                            break;
                        }
                    case "entity.Forms.Meta_Editor.ReflexiveControl":
                        {
                            ((entity.Forms.Meta_Editor.ReflexiveControl)this.Controls[counter]).SaveRecursively();
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Ident":
                        {
                            ((entity.Forms.Meta_Editor.Ident)this.Controls[counter]).Save();
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Float":
                        {
                            ((entity.Forms.Meta_Editor.Float)this.Controls[counter]).Save();
                            break;
                        }
                    case "entity.Forms.Meta_Editor.EntStrings":
                        {
                            ((entity.Forms.Meta_Editor.EntStrings)this.Controls[counter]).Save() ;
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Bitmask":
                        {
                            ((entity.Forms.Meta_Editor.Bitmask)this.Controls[counter]).Save();
                            break;
                        }
                    case "entity.Forms.Meta_Editor.DataValues":
                        {
                            ((DataValues)this.Controls[counter]).Save();
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Enums":
                        {
                            ((Enums)this.Controls[counter]).Save();
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Indices":
                        {
                            ((Indices)this.Controls[counter]).Save();
                            break;
                        }
                }
            }
        }
        //public void PokeRecursively()
        //{
        //    for (int counter = 0; counter < this.Controls.Count; counter++)
        //    {
        //        switch (this.Controls[counter].GetType().ToString())
        //        {
        //            case "entity.Forms.Meta_Editor.SID":
        //                {
        //                    ((SID)this.Controls[counter]).Poke();
        //                    break;
        //                }
        //            case "entity.Forms.Meta_Editor.ReflexiveControl":
        //                {
        //                    ((ReflexiveControl)this.Controls[counter]).PokeRecursively();
        //                    break;
        //                }
        //            case "entity.Forms.Meta_Editor.Ident":
        //                {
        //                    ((Ident)this.Controls[counter]).Poke();
        //                    break;
        //                }
        //            case "entity.Forms.Meta_Editor.Bitmask":
        //                {
        //                    ((Bitmask)this.Controls[counter]).Poke();
        //                    break;
        //                }
        //            case "entity.Forms.Meta_Editor.DataValues":
        //                {
        //                    ((DataValues)this.Controls[counter]).Poke();
        //                    break;
        //                }
        //            case "entity.Forms.Meta_Editor.Enums":
        //                {
        //                    ((Enums)this.Controls[counter]).Poke();
        //                    break;
        //                }
        //            case "entity.Forms.Meta_Editor.Indices":
        //                {
        //                    ((Indices)this.Controls[counter]).Poke();
        //                    break;
        //                }
        //        }
        //    }
        //}
        public void SetFocusRecursively(int LineToCheck)
        {
            if (this.LineNumber == LineToCheck)
                this.Focus();
            for (int counter = 0; counter < this.Controls.Count; counter++)
            {
                switch (this.Controls[counter].GetType().ToString())
                {
                    case "entity.Forms.Meta_Editor.SID":
                        {
                            ((entity.Forms.Meta_Editor.SID)this.Controls[counter]).SetFocus(LineToCheck);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.ReflexiveControl":
                        {
                            ((entity.Forms.Meta_Editor.ReflexiveControl)this.Controls[counter]).SetFocusRecursively(LineToCheck);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Ident":
                        {
                            ((entity.Forms.Meta_Editor.Ident)this.Controls[counter]).SetFocus(LineToCheck);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.EntStrings":
                        {
                            ((entity.Forms.Meta_Editor.EntStrings)this.Controls[counter]).SetFocus(LineToCheck);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Bitmask":
                        {
                            ((entity.Forms.Meta_Editor.Bitmask)this.Controls[counter]).SetFocus(LineToCheck);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.DataValues":
                        {
                            ((DataValues)this.Controls[counter]).SetFocus(LineToCheck);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Enums":
                        {
                            ((Enums)this.Controls[counter]).SetFocus(LineToCheck);
                            break;
                        }
                    case "entity.Forms.Meta_Editor.Indices":
                        {
                            ((Indices)this.Controls[counter]).SetFocus(LineToCheck);
                            break;
                        }
                }
            }
        }
    }
}
