using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Halo3Map.Meta_Editor.Controls
{
    public partial class Ident : UserControl
    {
        public bool visible;
        public int mapnumber;
        public int offset;

        bool loneID;

        public Ident(Base_Object.Ident ident)
        {
            InitializeComponent();
            mapnumber = ident.mapnumber;
            offset = ident.offset;
            loneID = ident.loneID;
            visible = ident.visible;

            label1.Text = ident.name;
            comboBox1.Text = ident.tagtype;
            comboBox2.Text = ident.filename;

            comboBox1.Items.Add("null");
            comboBox2.Items.Add("null");

            Load_Tag_Class_List();
            Load_Tag_List(ident.tagtype);
        }
        public void Save()
        {
            if (loneID)
            {
                Maps.map[mapnumber].io.Out.BaseStream.Position = offset;
                int id = Maps.map[mapnumber].findIndexNumber(comboBox1.Text, comboBox2.Text);
                Maps.map[mapnumber].io.Out.Write((short)Maps.map[mapnumber].index_items.Ident[id]);
            }
            else
            {
                Maps.map[mapnumber].io.Out.BaseStream.Position = offset - 12;
                int id = Maps.map[mapnumber].findIndexNumber(comboBox1.Text, comboBox2.Text);
                Maps.map[mapnumber].io.Out.Write(comboBox1.Text.ToCharArray());
                Maps.map[mapnumber].io.Out.BaseStream.Position += 8;
                Maps.map[mapnumber].io.Out.Write((short)Maps.map[mapnumber].index_items.Ident[id]);
            }
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            Load_Tag_List(comboBox1.Items[comboBox1.SelectedIndex].ToString());
        }

        public void Load_Tag_Class_List()
        {
            comboBox1.Items.Clear();
            for (int i = 0; i < Maps.map[mapnumber].index_items.tag_classes.class_type.Length; i++)
            {
                comboBox1.Items.Add(Maps.map[mapnumber].index_items.tag_classes.class_type[i]);
            }
        }

        public void Load_Tag_List(string type)
        {
            comboBox2.Items.Clear();
            for (int i = 0; i < Maps.map[mapnumber].index_header.meta_count; i++)
            {
                if (Maps.map[mapnumber].index_items.Name[i] != null && comboBox1.Text == Maps.map[mapnumber].index_items.Class[i])
                {
                    comboBox2.Items.Add(Maps.map[mapnumber].index_items.Name[i]);
                }
            }
        }
    }
}
