using System;
using System.Collections.Generic;
using System.Text;
using ForgePC.IFP;
using H3Dev.Map;
using ForgePC.Map;

namespace Halo3Map.Map
{
    public static class Meta_Sizes
    {
        #region Get Size
        public static int Get_Size(string type)
        {
            switch (type)
            {
                case "<fx>":
                    return 0x1c;
                case "ant!":
                    return 0x1ac;
                case "bipd":
                    return 0x718;
                case "bitm":
                    return 0xa4;
                case "bkey":
                    return 0x54;
                case "bloc":
                    return 0xfc;
                case "bmp3":
                    return 0x5c;
                case "bsdt":
                    return 0x54;
                case "cddf":
                    return 0x28;
                case "cfxs":
                    return 0xc4;
                case "chad":
                    return 0x64;
                case "char":
                    return 0x1a68;
                case "chdt":
                    return 0x18;
                case "chgd":
                    return 0xba8;
                case "clts":
                    return 0x195a4;
                case "clwd":
                    return 0xa5c;
                case "cntl":
                    return 0xc;
                case "coll":
                    return 0x40;
                case "colo":
                    return 0xc;
                case "crea":
                    return 0x0;
                case "ctrl":
                    return 0x1cc;
                case "dctr":
                    return 0xc4;
                case "decs":
                    return 0x24;
                case "draw":
                    return 0x49d4;
                case "drdf":
                    return 0xc;
                case "dsrc":
                    return 0x1c;
                case "effe":
                    return 0x5c;
                case "eqip":
                    return 0x260;
                case "<foot":
                    return 0xc;
                case "glps":
                    return 0x1554;
                case "glvs":
                    return 0x28;
                case "goof":
                    return 0x10;
                case "grup":
                    return 0x5c;
                case "hlmt":
                    return 0x1bc;
                case "hlsl":
                    return 0x4c;
                case "jmad":
                    return 0x104;
                case "jmrq":
                    return 0xc;
                case "jpt!":
                    return 0xe8;
                case "lens":
                    return 0x90;
                case "ligh":
                    return 0x94;
                case "lsnd":
                    return 0x40;
                case "lst3":
                    return 0xbc;
                case "lswd":
                    return 0x90;
                case "ltvl":
                    return 0xc;
                case "mach":
                    return 0x208;
                case "matg":
                    return 0x5f60;
                case "mdl3":
                    return 0x64;
                case "mode":
                    return 0x1b4;
                case "mulg":
                    return 0x50;
                case "perf":
                    return 0xc;
                case "phmo":
                    return 0x18c; 
                default:
                    return 0x0;
            }


        }
        #endregion
        public static int Calculate_Size_wIFP(ref IFPIO ifp, Meta meta, int mapnumber)
        {
            int size = ifp.headerSize;

            foreach (object o in ifp.items)
            {
                IFPIO.BaseObject tempbase = (IFPIO.BaseObject)o;

                switch (tempbase.ObjectType)
                {
                    case IFPIO.ObjectEnum.Reflexive:
                        IFPIO.Reflexive tempreflex = (IFPIO.Reflexive)tempbase;

                        Maps.map[mapnumber].io.In.BaseStream.Position = meta.Offset + tempreflex.offset;
                        int chunkcount = Maps.map[mapnumber].io.In.ReadInt32();
                        size += chunkcount * tempreflex.chunkSize;
                        int translation = Maps.map[mapnumber].io.In.ReadInt32() - meta.Magic;
                        break;
                }
            }

            return size;
        }        
    }
}
