using System;
using System.Collections.Generic;
using System.Text;
using Halo3Map.Map;
using Halo3Map;

namespace ForgePC
{
    public static class MiscFunctions
    {
        /// <summary>
        /// Calculates amount of padding needed for a block of data
        /// </summary>
        /// <param name="size">Size of data block</param>
        /// <param name="paddingchunksize">Amount to pad(ex. 512, 1024, 2048, ect</param>
        /// <returns>Padding Size</returns>
        public static int Padding(int size, int paddingchunksize)
        {
            int temp1 = 0;
            Math.DivRem(size, paddingchunksize, out temp1);
            if (temp1 == 0) { return 0; }
            int temp2 = paddingchunksize - temp1;
            return temp2;
        }

        public static string GetMapInfoFileName(string internalname, Map_Type type)
        {
            string path = "";
            if (type == Map_Type.multi_player)
            {
                path = AppSettings.Settings.MapFolder + "\\images\\m_" + internalname + ".blf";
            }
            else if (type == Map_Type.single_player)
            {
                string[] temp = internalname.Split('_');
                path = AppSettings.Settings.MapFolder + "\\images\\c_" + temp[0] + ".blf";                
            }
            if (System.IO.File.Exists(path)) 
            {
                return path;
            }
            else 
            {                 
                return AppSettings.Settings.MapFolder + "\\images\\term_8.blf";
            }                
        }
    }
}
