using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Halo3Map.IO;

namespace Halo3Map.plugins
{
    public class H3Reflexive<T> : List<T> where T : Chunk
    {
        private int chunkCount;
        public int ChunkCount { get { return chunkCount; } }

        private uint pointer;
        public uint Pointer { get { return pointer; } }

        private int mapOffset;
        public int MapOffset { get { return mapOffset; } }

        private int chunkSize;

        public H3Reflexive(EndianReader br)
        {
            Type t = typeof(T);
            object[] attributes = t.GetCustomAttributes(typeof(SizeAttribute), false);
            if (attributes.Length > 0)
                chunkSize = ((SizeAttribute)attributes[0]).Size;
            else
                MessageBox.Show("There is no size for this! Chunk Type: " + t.ToString());

            Read(br);
        }

        public void Read(EndianReader br)
        {
            chunkCount = br.ReadInt32();
            pointer = br.ReadUInt32();
            mapOffset = (int)(pointer - br.magic);

            if (chunkCount == 0)
                return;

            br.SeekTo(mapOffset);
            for (int x = 0; x < chunkCount; x++)
            {
                T reflexive = (T)Activator.CreateInstance(typeof(T));
                reflexive.Read(br);
                Add(reflexive);
            }
        }
    }
}