using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;

namespace Halo3Map.plugins
{
    public class H3Tag : Chunk
    {
        private string author;
        public string Author { get { return author; } }

        private string tagType;
        public string TagType { get { return tagType; } }

        private double version;
        public double Version { get { return version; } }

        private int mapOffset;
        public int MapOffset { get { return mapOffset; } set { mapOffset = value; } }

        public H3Tag()
        {
            object[] attributes = this.GetType().GetCustomAttributes(typeof(TagAttribute), false);
            if (attributes.Length > 0)
            {
                TagAttribute tagA = (TagAttribute)attributes[0];
                author = tagA.Author;
                tagType = tagA.TagType;
                version = tagA.Version;
            }
            else
                MessageBox.Show("There is no information for this tag! Tag: " + this.GetType());
        }

        public override void Read(Halo3Map.IO.EndianReader br)
        {
            br.SeekTo(mapOffset);
            base.Read(br);
        }
    }
}