using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Reflection;

namespace ForgePC
{
    public class EngineerLibrary : UserControl
    {
        public string LibraryName;
        public string Author;
        public string TagType = "*.*";

        public EngineerLibrary()
        {
            this.Dock = DockStyle.Fill;
            this.LibraryName = "Default Library";
            InitializeComponent();
        }

        public virtual void Run(int mapnum, ref ToolStripProgressBar progressbar)
        {

        }

        public string GetName()
        {
            return this.LibraryName;
        }

        private void InitializeComponent()
        {
            this.SuspendLayout();
            // 
            // EngineerLibrary
            // 
            this.Name = "EngineerLibrary";
            this.ResumeLayout(false);
        }
    }

    public class LibraryManager
    {
        public LibraryManagerList Library = new LibraryManagerList();

        public class LibraryManagerList : List<EngineerLibrary>
        {
            public void Add(string libraryPath)
            {
                foreach (FileInfo file in new DirectoryInfo(libraryPath).GetFiles())
                {
                    Assembly asm;
                    try
                    {
                        asm = Assembly.LoadFile(file.FullName);
                    }
                    catch
                    {
                        continue;
                    }
                    foreach (Type type in asm.GetTypes())
                    {
                        if (type.BaseType == typeof(EngineerLibrary))
                        {
                            this.Add((EngineerLibrary)Activator.CreateInstance(type));
                        }
                    }
                }
            }
        }
    }
}
